ArrayList<Shape> shapes = new ArrayList<Shape>();

int formResolution = 5; // number of points on the curve
int stepSize = 2; // how much distortion it has
float distortionFactor = 1;
float initRadius = 10; // size of the circle
float centerX, centerY;
float[] x = new float[formResolution];
float[] y = new float[formResolution];

void setup() {
  size(640, 640);
  stroke(1);
  frameRate(5);
  
  centerX = width/2; 
  centerY = height/2;
  float angle = radians(360/float(formResolution));
  for (int i=0; i<formResolution; i++){
    x[i] = cos(angle*i) * initRadius;
    y[i] = sin(angle*i) * initRadius;  
  }
}

void draw() {
  background(255);
  
  shapes.add(new Shape());
  shapes.add(new Shape());

  for (int i = 0; i < shapes.size (); i++) {
    Shape shape = shapes.get(i);
    fill(random(255));
    //fill(random(255), 150, 150);
    /* Formular for landscape */
    float boundary = 200-abs(sin(radians(shape.loc.x)))*cos(radians(shape.loc.x/2))*100;
    shape.display(boundary);
  }
}
class Shape {
  PVector loc, acc, vel, gravity;
  float r, mass;
  float alpha = 200;

  Shape() {
    r = random(2, 20);

    loc = new PVector(random(-200, width+200), -r);
    vel = new PVector();
    acc = new PVector();

    mass = 50/r;
  }

  void applyForce(PVector force) {
    acc.add(PVector.div(force, mass));
  }

  void display(float boundary) {
    vel.add(acc);
    loc.add(vel);
    acc.mult(0);
    if (loc.y > height-boundary) {
      vel.y *= 0.9;
      vel.x = 0;
      alpha--;
      if (alpha > 0) {
      } else {
        shapes.remove(this);
      }
    } else {
      gravity = new PVector(map(mouseX, 0, width, -0.03, 0.03), map(mouseY, 0, height, 0.01, 0.1));
      
      beginShape();
      // start controlpoint
      centerX = loc.x;
      centerY = loc.y;
  
      for (int i=0; i<formResolution; i++){
        x[i] += random(-stepSize,stepSize);
        y[i] += random(-stepSize,stepSize);
      }
  
      curveVertex(x[formResolution-1]+centerX, y[formResolution-1]+centerY);
    
      // only these points are drawn
      for (int i=0; i<formResolution; i++){
        curveVertex(x[i]+centerX, y[i]+centerY);
      }
      curveVertex(x[0]+centerX, y[0]+centerY);
    
      // end controlpoint
      curveVertex(x[1]+centerX, y[1]+centerY);
      endShape();
      applyForce(gravity);
    }
  }
}

void keyReleased() {
  if (key == 's' || key == 'S') saveFrame("Shape"+"_##.png");
  if (key == DELETE || key == BACKSPACE) background(255);
}